#include "config.h"
#include "io.h"

#include <poll.h>
#include <unistd.h>
#include <errno.h>
#include <stdio.h>

bool safewrite(int fd, const char *data, size_t size) {
	ssize_t r;
	struct pollfd p = {fd, POLLOUT|POLLERR|POLLHUP|POLLNVAL, 0};

	while(size) {
		r = write(fd, data, size);
		if(r == -1) {
			switch(errno) {
				default:
					perror("write()");
					return false;
				case EAGAIN:
					poll(&p, 1, -1);
					break;
				case EINTR:
					break;
			}
		} else if(r == 0) {
			/* huh? */
			return false;
		} else {
			size -= r;
			data += r;
		}
	}
	return true;
}
