#include "config.h"
#include "error.h"
#include "iovec.h"

#include <errno.h>
#include <unistd.h>
#include <limits.h>
#include <sys/uio.h>

bool iovec_write(int fd, struct iovec *iov, uint32_t count) {
	ssize_t r, len;

	if(!count)
		return true;

	while(count) {
		r = writev(fd, iov, (int)(count > IOV_MAX ? IOV_MAX : count));
		if(r == -1)
			return ok(errno, "writev");
		if(!r)
			return ok(ECOMM, "writev");
		while(r) {
			len = iov->iov_len;
			if(r < len) {
				iov->iov_base = (char *)iov->iov_base + r;
				iov->iov_len -= r;
				r = 0;
			} else {
				r -= len;
				iov++;
				count--;
			}
		}
	}

	return true;
}
